
// commented-out because this can be included only once
//#ifndef _SQLSCHEMA_H
//#define _SQLSCHEMA_H

const char *sql_schema =
"\n"
"--- bool aktywne is there to ensure data integrity (if this would be editable)\n"
"\n"
"CREATE TABLE stawka_vat (\n"
"	id			INTEGER NOT NULL,\n"
"	nazwa		TEXT NOT NULL DEFAULT '',\n"
"	stawka		DECIMAL(6,3),\n"
"	aktywne		INTEGER,\n"
"	PRIMARY KEY(id)\n"
");\n"
"\n"
"INSERT INTO stawka_vat (id, nazwa, stawka, aktywne) VALUES (1, '0%', 0, 1);\n"
"INSERT INTO stawka_vat (id, nazwa, stawka, aktywne) VALUES (2, '3%', 3, 1);\n"
"INSERT INTO stawka_vat (id, nazwa, stawka, aktywne) VALUES (3, '7%', 7, 1);\n"
"INSERT INTO stawka_vat (id, nazwa, stawka, aktywne) VALUES (4, '22%', 22, 1);\n"
"INSERT INTO stawka_vat (id, nazwa, stawka, aktywne) VALUES (5, 'zwolnione', 0, 1);\n"
"\n"
"CREATE TABLE firma (\n"
"	id			INTEGER NOT NULL,\n"
"	nazwa		TEXT,\n"
"	symbol		TEXT NOT NULL DEFAULT '',\n"
"	adres		TEXT,\n"
"	kod			TEXT,\n"
"	miejscowosc	TEXT,\n"
"	telefon		TEXT,\n"
"	email		TEXT,\n"
"	nip			TEXT,\n"
"	regon		TEXT,\n"
"	bank		TEXT,\n"
"	konto		TEXT,\n"
"\n"
"	odbiorca	INTEGER,\n"
"	dostawca	INTEGER,\n"
"	aktywny		INTEGER,\n"
"	zablokowany	INTEGER,\n"
"	PRIMARY KEY(id,symbol)\n"
");\n"
"--- vatid points to stawka_vat table\n"
"--- sqlite doesn't enforce constrains, but data should be set conforming by app \n"
"\n"
"CREATE TABLE towar (\n"
"	id			INTEGER NOT NULL,\n"
"	nazwa		TEXT,\n"
"	symbol		TEXT NOT NULL DEFAULT '',\n"
"	pkwiu		TEXT,\n"
"	jm			TEXT,\n"
"	usluga		INTEGER NOT NULL DEFAULT 0,\n"
"	dodany		DATE,\n"
"\n"
"	vatid		INTEGER,\n"
"	netto		DECIMAL(12,2),\n"
"	zakupu		DECIMAL(12,2),\n"
"	marza		DECIMAL(12,2),\n"
"	rabat		DECIMAL(12,2),\n"
"	kurs		DECIMAL(12,2),\n"
"	clo			DECIMAL(12,2),\n"
"\n"
"	notatki 	TEXT,\n"
"	magazyn		DECIMAL(12,2) NOT NULL DEFAULT 0,\n"
"	magzmiana	DATETIME,\n"
"	PRIMARY KEY(id,symbol)\n"
");\n"
"\n"
"CREATE TABLE faktura (\n"
"	id 					INTEGER NOT NULL,\n"
"	nazwa				TEXT,\n"
"\n"
"	data_wystawienia	DATE,\n"
"	miejsce_wystawienia	TEXT,\n"
"	data_sprzedazy		DATE,\n"
"\n"
"	termin_zaplaty		DATE,\n"
"	sposob_zaplaty		TEXT,\n"
"\n"
"	srodek_transportu	TEXT,\n"
"\n"
"	wystawil			TEXT,\n"
"	uwagi				TEXT,\n"
"\n"
"	zapl_dnia			DATE,\n"
"	zapl_kwota			TEXT,\n"
"\n"
"	--- odbiorca - kopia struktury z firmy\n"
"	onazwa				TEXT,\n"
"	oadres				TEXT,\n"
"	okod				TEXT,\n"
"	omiejscowosc		TEXT,\n"
"	otelefon			TEXT,\n"
"	oemail				TEXT,\n"
"	onip				TEXT,\n"
"	oregon				TEXT,\n"
"	obank				TEXT,\n"
"	okonto				TEXT,\n"
"\n"
"	PRIMARY KEY(id)\n"
");\n"
"CREATE TABLE pozycjafakt (\n"
"	id			INTEGER NOT NULL,\n"
"	fakturaid	INTEGER NOT NULL,\n"
"	lp			INTEGER NOT NULL,\n"
"	ilosc		DECIMAL(12,2) NOT NULL,\n"
"\n"
"	--- towar - kopia struktury z towar\n"
"	nazwa		TEXT,\n"
"	pkwiu		TEXT,\n"
"	jm			TEXT,\n"
"\n"
"	vatid		INTEGER,\n"
"	netto		DECIMAL(12,2),\n"
"	rabat		DECIMAL(12,2),\n"
"\n"
"	PRIMARY KEY(id,fakturaid)\n"
");\n"
"CREATE TABLE konfiguracja (\n"
"--- dane firmy\n"
"	nazwa 		TEXT,\n"
"	adres 		TEXT,\n"
"	kod			TEXT,\n"
"	miejscowosc	TEXT,\n"
"	telefon		TEXT,\n"
"	email		TEXT,\n"
"	nip			TEXT,\n"
"	regon		TEXT,\n"
"	bank		TEXT,\n"
"	konto		TEXT,\n"
"--- konfiguracja wydruku\n"
"	p_mode		INTEGER NOT NULL DEFAULT 0,\n"
"	p_typ		INTEGER NOT NULL DEFAULT 0,\n"
"	p_writepath	TEXT DEFAULT '/boot/home/',\n"
"	p_textcols	INTEGER NOT NULL DEFAULT 80,\n"
"	p_texteol	INTEGER NOT NULL DEFAULT 0,\n"
"	p_htmltemplate	TEXT DEFAULT '/boot/home/vatszablon.html',\n"
"	p_lkopii	INTEGER NOT NULL DEFAULT 1,\n"
"--- konfiguracja faktur\n"
"	f_wystawil	TEXT,\n"
"	f_numprosta	INTEGER NOT NULL DEFAULT 0,\n"
"	paydays		INTEGER NUT NULL DEFAULT 30,\n"
"--- marker\n"
"	wersja		TEXT DEFAULT '" APP_DBVERSION "',\n"
"	zrobiona	INTEGER DEFAULT 1\n"
");\n"
"\n"
"INSERT INTO konfiguracja (zrobiona) VALUES (1);\n"
"\n"
;

//#endif
